/*
 * 
 * iis_perl_problem
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "Perl.exe and IIS security"
#define DESC "\
There is a problem with perl.exe similar to the issue discussed in KB\n\
article Q193689 where the physical disk location of a virtual web directory\n\
can be ascertained.\n\n\
In all versions of IIS, where a  website has been configured to interpret\n\
perl scripts using the perl executable (perl.exe), a problem exists where a\
request for a non-existent file will return the physical location on a disk\n\
of a web directory.\n\
This may be of some interest to attackers who gain more knowledge about\n\
the attacked target\n\
Risk factor : Low"
#define COPYRIGHT "mnemonix <mnemonix@GLOBALNET.CO.UK>"
#define SUMM "attempts to find the location of the remote web root"

PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	return(0);
}


PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{

	if(!host_get_port_state(args, 80))return(0);
	else
        {
         int soc = open_sock_tcp(args, 80);
         char * buf;
         
         if(soc < 0)return(0);
         buf = emalloc(512);
         sprintf(buf, "GET /scripts/no-such-file.pl HTTP/1.0\n\n");
         send(soc, buf, strlen(buf), 0);
         bzero(buf, strlen(buf));
         recv(soc, buf, 511,0);
         if(strstr(buf, "perl script"))
         { 
          char * start;
          char * end;
          char * report;
          start = strstr(buf, "perl script");
          if(start)start+=2;
          end = strstr(start, "\":");
          if(end)end[0]=0;
          report = emalloc(512);
          sprintf(report,"\
The remote web files location is\n\
%s\n\
This may be of some interest to hackers\n\
who gain more knowledge about their targets\n\
this way.\n\
Solution : use perlis.dll instead of the perl\n\
perl interpreter perl.exe", start ? buf:start);
	   post_info(args, 80, report);
           efree(&report);
         }
         efree(&buf);
        return(0);
}
	return(0);
}

