/*
 * 
 * sendmail_relaying
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>

#define NAME "Sendmail Relaying"
#define DESC "\
This plugin determines whether your sendmail server\n\
can be used as a mail relay. If it can, then it may\n\
be subject to spammers who can then relay their mails\n\
Mail relaying is bad because it overloads your server\n\
since the spammers usually send thousands of mails.\n\
Risk factor : low"

#define COPYRIGHT "no copyright"
#define SUMM "checks whether sendmail can do relaying"




PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Sendmail");
	return(0);
}




PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int soc;
	char * buf;
	int expn=0,vrfy=0;
	
	if(host_get_port_state(args, 25)<=0)return(0);
	soc = open_sock_tcp(args, 25);
	if(soc<0)return(-1);
	buf = emalloc(2048);
	recv_line(soc, buf, 2048);
        bzero(buf, strlen(buf));
        sprintf(buf, "HELO nessus.org\n");
        send(soc, buf, strlen(buf), 0);
	bzero(buf, strlen(buf));
        recv_line(soc, buf, 2048);
        sprintf(buf, "MAIL FROM: test_1@nessus.org\n");
        send(soc, buf, strlen(buf), 0);
	recv_line(soc, buf, 2048);
        bzero(buf, strlen(buf));
        sprintf(buf, "RCPT TO: test_2@nessus.org\n");
        send(soc, buf, strlen(buf), 0);
        bzero(buf, strlen(buf));
        recv_line(soc, buf, 2048);
        if(!strncmp(buf, "250", 3))
        {
         post_info(args, 25,"\
The remote sendmail allows mail \n\
relaying. Spammers can send mail \n\
using this host\n\
Solution: see \n\
 http://www.sendmail.org/antispam.html");
 	}
	socket_close(soc);
	efree(&buf);
	return(0);
}
